function love.load()
    love.graphics.setBackgroundColor(240,235,210)
    orangetile = love.graphics.newImage("images/tile_orange.png")
    purpletile = love.graphics.newImage("images/tile_purple.png")
    bluetile = love.graphics.newImage("images/tile_blue.png")
    greentile = love.graphics.newImage("images/tile_green.png")
    white = love.graphics.newImage("images/white.png")
    arrow = love.graphics.newImage("images/arrow.png")
    startimage = love.graphics.newImage("images/start.png")
    finishimage = love.graphics.newImage("images/finish.png")
    mimage = love.graphics.newImage("images/m.png")
    fimage = love.graphics.newImage("images/f.png")
    font = love.graphics.newFont(36)
    gameovertext = love.graphics.newText(font, "Game Over!")
    music = love.audio.newSource("sounds/loop2.mp3")
    music:setLooping(true)
    music:play()
    ismusic = true
    donefx = love.audio.newSource("sounds/done.mp3")
    donefx:setLooping(false)
    deadfx = love.audio.newSource("sounds/dead.mp3")
    deadfx:setLooping(false)
    isfx = true
    font = love.graphics.newFont(24)
    level = 1
    lives = 3
    gameover = false
    finished = false
    files = love.filesystem.getDirectoryItems("maps")
    levelcount = 0
    for _,level in ipairs(files) do
        levelcount = levelcount + 1
    end
    maps = {}
    for _,m in ipairs(files) do table.insert(maps, "maps/"..m) end
    table.sort(maps)
    start = true
    newGame()
end

function love.update(dt)
    if not dead and not start and not gameover and not finished then
        time = time + dt
    if isgoing then
        player.x = player.x + player.velx * dt
        player.y = player.y + player.vely * dt
        distx = distx - player.velx *dt
        disty = disty - player.vely * dt
        if distx < 1 and distx > -1 then
            distx = 0
            player.velx = 0
            player.x = targetx
            isgoing = false
        end
        if disty < 1 and disty> -1 then
            disty = 0
            player.vely = 0
            player.y = targety
            isgoing = false
        end
    else
        for i=1,#blackcorners,1 do
            local x,y = blackcorners[i][1],blackcorners[i][2]
            if x == player.x - 16 and y == player.y - 10 then
                if isfx then
                    deadfx:play()
                end
                dead = true
                lives = lives - 1
                if lives == 0 then
                    gameover = true
                end
            end
        end
        gonecount = 0
        for i=1,#tilecorners,1 do
            local tiletable = tilecorners[i]
            local tiletype,isover,isgone,x,y = tiletable[1],tiletable[2],tiletable[3],tiletable[4],tiletable[5]
            if isgone then
                if x == player.x - 16 and y == player.y - 10 then
                    if isfx then
                        deadfx:play()
                    end
                    dead = true
                    lives = lives - 1
                    if lives == 0 then
                        gameover = true
                    end
                end
            end
            if isover then
                if x ~= player.x - 16 or y ~= player.y - 10 then
                    gonecount = gonecount + 1
                end
                if x == player.x - 16 and y == player.y - 10 then
                    if time > 2 then
                        tiletable[3] = true
                        tilecorners[i] = tiletable
                        if isfx then
                            deadfx:play()
                        end
                        dead = true
                        lives = lives - 1
                        if lives == 0 then
                            gameover = true
                        end
                     end
                end
            end
            if tiletype == "orange" then
                if not isover then
                    if x == player.x - 16 and y == player.y - 10 then
                        tiletable[2] = true
                        tilecorners[i] = tiletable
                    end
                else
                    if x ~= player.x - 16 or y ~= player.y - 10 then
                        tiletable[3] = true
                        tilecorners[i] = tiletable
                    end
                end
            end
        end
        for i=1,#tilecorners,1 do
            local tiletable = tilecorners[i]
            local tiletype,isover,isgone,x,y = tiletable[1],tiletable[2],tiletable[3],tiletable[4],tiletable[5]
            if tiletype == "green" then
                if x == player.x - 16 and y == player.y - 10 then
                    if gonecount == tilecount then
                        if isfx then
                            donefx:play()
                        end
                        level = level + 1
                        if level > levelcount then
                            finished = true
                        else
                            newGame()
                            break
                        end
                    else
                        if isfx then
                            deadfx:play()
                        end
                        dead = true
                        lives = lives - 1
                        if lives == 0 then
                            gameover = true
                        end
                    end
                end
            end
        end
    end
    end
end

function love.draw()
    if not start and not finished then
	    drawMap()
        if not dead then
            love.graphics.setColor(255, 255, 255)
        else
            love.graphics.setColor(255,0,0)
        end
        love.graphics.draw(player.img, player.x, player.y)
        love.graphics.setColor(255,255,255)
        if up then
            love.graphics.draw(arrow, 30, 50)
        elseif down then
            love.graphics.draw(arrow, 30, 110, 0, 1, -1)
        end
        if gameover then
            love.graphics.setColor(0,0,0)
            love.graphics.draw(gameovertext, 400-gameovertext:getWidth() / 2, 300 - gameovertext:getHeight() / 2)
         end
        if ismusic then
            love.graphics.setColor(255, 255, 255)
            love.graphics.draw(mimage, 720, 20)
        else
            love.graphics.setColor(255,0,0)
            love.graphics.draw(mimage, 720, 20)
        end
        if isfx then 
            love.graphics.setColor(255, 255, 255)
            love.graphics.draw(fimage, 720, 64)
        else
            love.graphics.setColor(255,0,0)
            love.graphics.draw(fimage,720, 64)
        end
        love.graphics.setColor(255, 255, 255)
        for i=1,lives,1 do
            love.graphics.draw(player.img, 30 * i, 10)
        end
    elseif start then
        love.graphics.setColor(255,255,255)
        love.graphics.draw(startimage, 0, 0)
    else
        love.graphics.setColor(255,255,255)
        love.graphics.draw(finishimage, 0, 0)
    end
end

function love.keypressed(key)
    if key == "escape" and not up and not down and start and not gameover then
        love.event.quit()
    elseif key == "escape" and not up and not down and not start and not gameover then
        level = 1
        lives = 3
        dead = false
        start = true
    elseif key == "escape" and (up or down) and not start and not gameover then
        up = false
        down = false
    end
    if key == "space" and dead and not gameover then
        dead = false
        newGame()
    end
    if key == "space" and start then
        start = false
        newGame()
    end
    if (key == "space" or key=="escape") and gameover and not start then
        level = 1
        lives = 3
        dead = false
        gameover = false
        start = true
        newGame()
    end
    if (key == "space" or key == "escape") and finished then
        love.event.quit()
    end
    if key == "m" then
        ismusic = not ismusic
        if ismusic then
            music:play()
        else
            music:stop()
        end
    end
    if key == "f" then
        isfx = not isfx
    end
    if key == "f1" and not start and not gameover then
        level = level + 1
        if level > levelcount then
            finished = true
        else
            newGame()
        end
    end
    if key == "right" then
        if not isgoing  and not start then
            if down then
                player.velx = 50
                player.vely = 78
                distx = 32
                disty = 50
            elseif up then
                player.velx = 50
                player.vely = -78
                distx = 32
                disty = -50
            else
                player.velx = 100
                player.vely = 0
                distx = 64
                disty = 50
            end
            time = 0
            isgoing = true
            down = false
            up = false
            targetx = player.x + distx
            targety = player.y + disty
        end
    end
    if key == "down" then
        if not start and not dead and not gameover and not finished then
            down = true
            up = false
        end
    end
    if key == "up" then
        if not start and not dead and not gameover and not finished then
            up = true
            down = false
        end
    end
    if key == "left" then
        if not start then
            if up then
                player.velx = -50
                player.vely = -78
                distx = -32
                disty = -50
            elseif down then
                player.velx = -50
                player.vely = 78
                distx = -32
                disty = 50
            else
                player.velx = -100
                player.vely = 0
                distx = -64
                disty = 50
            end
            up = false
            down = false
            isgoing = true
            targetx = player.x + distx
            targety = player.y + disty
            time = 0
        end
    end
end

function loadMap(path)
    tileString = love.filesystem.load(path)()
    tilecorners = {}
    blackcorners = {}
    cb = 0
    bc = 0
    tilecount = 0
    tileTable = {}

    local width = #(tileString:match("[^\n]+"))

    for x = 1,width,1 do tileTable[x] = {} end

    local rowIndex,columnIndex = 1,1
    for row in tileString:gmatch("[^\n]+") do
        assert(#row == width, 'Map is not aligned: width of row ' .. tostring(rowIndex) .. ' should be ' .. tostring(width) .. ', but it is ' .. tostring(#row))
        columnIndex = 1
        for character in row:gmatch(".") do
            tileTable[columnIndex][rowIndex] = character
            if rowIndex%2 == 0 and rowIndex ~= 0 then
                dx = 132
            elseif rowIndex == 0 then
                dx = 0
            else
                dx = 100
            end
            if character == " " then
                bc = bc + 1
                blackcorners[bc] = {(columnIndex - 1)*64 + dx, (rowIndex - 1)*50 + 100}
            end
	        if character == "P" then
	            cb = cb + 1
	            tilecorners[cb] = { "purple", false,false, (columnIndex - 1)*64 + dx, (rowIndex - 1)*50 + 100, rowIndex, columnIndex }
	        end
	        if character == "O" then
	            cb = cb + 1
	            tilecorners[cb] = { "orange", false,false, (columnIndex - 1)*64 + dx, (rowIndex - 1)*50 + 100, rowIndex, columnIndex }
                tilecount = tilecount + 1
	        end
	        if character == "B" then
	            cb = cb + 1
	            tilecorners[cb] = { "blue", false, false,(columnIndex - 1)*64 + dx, (rowIndex - 1)*50 + 100, rowIndex, columnIndex }
	        end
	        if character == "G" then
	            cb = cb + 1
	            tilecorners[cb] = { "green", false,false, (columnIndex - 1)*64 + dx, (rowIndex - 1)*50 + 100, rowIndex, columnIndex }
	        end
	        if character == "b" then
	            cb = cb + 1
	            tilecorners[cb] = { "white", false, false,(columnIndex - 1)*64 + dx, (rowIndex - 1)*50 + 100, rowIndex, columnIndex }
	        end
            columnIndex = columnIndex + 1
        end
        rowIndex=rowIndex+1
    end
end

function drawMap()
    for _,tiletable in ipairs(tilecorners) do
        local tiletype,isover,isgone,x,y = tiletable[1], tiletable[2], tiletable[3],tiletable[4],tiletable[5]
        love.graphics.setColor(255, 255, 255)
        if not isgone then
            if tiletype == "purple" then
                love.graphics.draw(purpletile, x, y)
            elseif tiletype == "orange" then
                love.graphics.draw(orangetile, x, y)
            elseif tiletype == "green" then
                love.graphics.draw(greentile, x, y)
            end
            if isover then
                love.graphics.setColor(255, 255, 255, 100)
                love.graphics.draw(white, x, y)
            end
        end
    end
end

function newGame()
    time = 0
    gonecount = 0
    dead = false
    loadMap(maps[level])
    player = {}
    player.img = love.graphics.newImage("images/player.png")
    for i=1,#tilecorners,1 do
        local tiletable = tilecorners[i]
        local tiletype,isover,isgone,x,y = tiletable[1],tiletable[2],tiletable[3],tiletable[4],tiletable[5]
        if tiletype == "purple" then
            player.x, player.y = x + 16,y + 10
        end
    end
    player.velx = 0
    player.vely = 0
    isgoing = false
end
